/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Model205
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Model205 {
  @SerializedName("product_code")
  private String productCode = null;

  @SerializedName("origin_product_code")
  private String originProductCode = null;

  @SerializedName("is_default_product")
  private Boolean isDefaultProduct = null;

  @SerializedName("addon_codes")
  private AddonCodes addonCodes = null;

  @SerializedName("quote_code")
  private String quoteCode = null;

  @SerializedName("promo_code")
  private String promoCode = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("guarantees")
  private Model197 guarantees = null;

  @SerializedName("prices")
  private Model200 prices = null;

  @SerializedName("attachments")
  private Model174 attachments = null;

  @SerializedName("consents")
  private Model202 consents = null;

  @SerializedName("disclaimers")
  private Model204 disclaimers = null;

  public Model205 productCode(String productCode) {
    this.productCode = productCode;
    return this;
  }

   /**
   * Product code.
   * @return productCode
  **/
  @ApiModelProperty(example = "PRDINTERMEDIATE", required = true, value = "Product code.")
  public String getProductCode() {
    return productCode;
  }

  public void setProductCode(String productCode) {
    this.productCode = productCode;
  }

  public Model205 originProductCode(String originProductCode) {
    this.originProductCode = originProductCode;
    return this;
  }

   /**
   * Code of the origin product.
   * @return originProductCode
  **/
  @ApiModelProperty(example = "PRDBASIC", value = "Code of the origin product.")
  public String getOriginProductCode() {
    return originProductCode;
  }

  public void setOriginProductCode(String originProductCode) {
    this.originProductCode = originProductCode;
  }

  public Model205 isDefaultProduct(Boolean isDefaultProduct) {
    this.isDefaultProduct = isDefaultProduct;
    return this;
  }

   /**
   * Indicates if the product is supposed to be preselected by default.
   * @return isDefaultProduct
  **/
  @ApiModelProperty(example = "true", value = "Indicates if the product is supposed to be preselected by default.")
  public Boolean isIsDefaultProduct() {
    return isDefaultProduct;
  }

  public void setIsDefaultProduct(Boolean isDefaultProduct) {
    this.isDefaultProduct = isDefaultProduct;
  }

  public Model205 addonCodes(AddonCodes addonCodes) {
    this.addonCodes = addonCodes;
    return this;
  }

   /**
   * Get addonCodes
   * @return addonCodes
  **/
  @ApiModelProperty(required = true, value = "")
  public AddonCodes getAddonCodes() {
    return addonCodes;
  }

  public void setAddonCodes(AddonCodes addonCodes) {
    this.addonCodes = addonCodes;
  }

  public Model205 quoteCode(String quoteCode) {
    this.quoteCode = quoteCode;
    return this;
  }

   /**
   * Quote code.
   * @return quoteCode
  **/
  @ApiModelProperty(example = "d41d8cd98f00b204e9800998ecf8427e", value = "Quote code.")
  public String getQuoteCode() {
    return quoteCode;
  }

  public void setQuoteCode(String quoteCode) {
    this.quoteCode = quoteCode;
  }

  public Model205 promoCode(String promoCode) {
    this.promoCode = promoCode;
    return this;
  }

   /**
   * Promotion code provided on the request, it is sent with the product/addon on which it has been applied.
   * @return promoCode
  **/
  @ApiModelProperty(example = "GOODPROMO200", value = "Promotion code provided on the request, it is sent with the product/addon on which it has been applied.")
  public String getPromoCode() {
    return promoCode;
  }

  public void setPromoCode(String promoCode) {
    this.promoCode = promoCode;
  }

  public Model205 name(String name) {
    this.name = name;
    return this;
  }

   /**
   * name
   * @return name
  **/
  @ApiModelProperty(example = "Advanced", value = "name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Model205 description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Product marketing description
   * @return description
  **/
  @ApiModelProperty(example = "Advanced for more guarantees", value = "Product marketing description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Model205 guarantees(Model197 guarantees) {
    this.guarantees = guarantees;
    return this;
  }

   /**
   * Get guarantees
   * @return guarantees
  **/
  @ApiModelProperty(required = true, value = "")
  public Model197 getGuarantees() {
    return guarantees;
  }

  public void setGuarantees(Model197 guarantees) {
    this.guarantees = guarantees;
  }

  public Model205 prices(Model200 prices) {
    this.prices = prices;
    return this;
  }

   /**
   * Get prices
   * @return prices
  **/
  @ApiModelProperty(required = true, value = "")
  public Model200 getPrices() {
    return prices;
  }

  public void setPrices(Model200 prices) {
    this.prices = prices;
  }

  public Model205 attachments(Model174 attachments) {
    this.attachments = attachments;
    return this;
  }

   /**
   * Get attachments
   * @return attachments
  **/
  @ApiModelProperty(value = "")
  public Model174 getAttachments() {
    return attachments;
  }

  public void setAttachments(Model174 attachments) {
    this.attachments = attachments;
  }

  public Model205 consents(Model202 consents) {
    this.consents = consents;
    return this;
  }

   /**
   * Get consents
   * @return consents
  **/
  @ApiModelProperty(value = "")
  public Model202 getConsents() {
    return consents;
  }

  public void setConsents(Model202 consents) {
    this.consents = consents;
  }

  public Model205 disclaimers(Model204 disclaimers) {
    this.disclaimers = disclaimers;
    return this;
  }

   /**
   * Get disclaimers
   * @return disclaimers
  **/
  @ApiModelProperty(value = "")
  public Model204 getDisclaimers() {
    return disclaimers;
  }

  public void setDisclaimers(Model204 disclaimers) {
    this.disclaimers = disclaimers;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Model205 model205 = (Model205) o;
    return Objects.equals(this.productCode, model205.productCode) &&
        Objects.equals(this.originProductCode, model205.originProductCode) &&
        Objects.equals(this.isDefaultProduct, model205.isDefaultProduct) &&
        Objects.equals(this.addonCodes, model205.addonCodes) &&
        Objects.equals(this.quoteCode, model205.quoteCode) &&
        Objects.equals(this.promoCode, model205.promoCode) &&
        Objects.equals(this.name, model205.name) &&
        Objects.equals(this.description, model205.description) &&
        Objects.equals(this.guarantees, model205.guarantees) &&
        Objects.equals(this.prices, model205.prices) &&
        Objects.equals(this.attachments, model205.attachments) &&
        Objects.equals(this.consents, model205.consents) &&
        Objects.equals(this.disclaimers, model205.disclaimers);
  }

  @Override
  public int hashCode() {
    return Objects.hash(productCode, originProductCode, isDefaultProduct, addonCodes, quoteCode, promoCode, name, description, guarantees, prices, attachments, consents, disclaimers);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Model205 {\n");
    
    sb.append("    productCode: ").append(toIndentedString(productCode)).append("\n");
    sb.append("    originProductCode: ").append(toIndentedString(originProductCode)).append("\n");
    sb.append("    isDefaultProduct: ").append(toIndentedString(isDefaultProduct)).append("\n");
    sb.append("    addonCodes: ").append(toIndentedString(addonCodes)).append("\n");
    sb.append("    quoteCode: ").append(toIndentedString(quoteCode)).append("\n");
    sb.append("    promoCode: ").append(toIndentedString(promoCode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    guarantees: ").append(toIndentedString(guarantees)).append("\n");
    sb.append("    prices: ").append(toIndentedString(prices)).append("\n");
    sb.append("    attachments: ").append(toIndentedString(attachments)).append("\n");
    sb.append("    consents: ").append(toIndentedString(consents)).append("\n");
    sb.append("    disclaimers: ").append(toIndentedString(disclaimers)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

